# In debian, folloing packages are used:
#   poppler-utils pdftk imagemagick ffmpeg.
#
# sudo apt-get install poppler-utils pdftk imagemagick ffmpeg
#
require "numru/ggraph"
include NumRu

pardir = "../Earth_T21L26/0001"
#pardir = "../Earth_T42L26/0001"
#pardir = "../Earth_T21L52/0001"
flag_parallel_file = true
#flag_parallel_file = false

vnames_ty      = [ "SurfTemp", "SurfAlbedo", "Rain", "Snow", "PRCP" ]
vnames_xy      = [ "SurfTemp", "SurfAlbedo", "Rain", "Snow", "PRCP" ]
vnames_vint_xy = [ "QH2OVap", "QH2OLiq", "QH2OSol" ]
vnames_yp      = [ "U", "AngMom", "V", "MSF", "OMG", "Temp", "PotTemp", "StatStab", "QH2OVap", "QH2OLiq", "QH2OSol" ]


vname_ps = "Ps"

if flag_parallel_file then
  file_rank  = '_rank\?\?\?\?\?\?'
  file_rank0 = '_rank000000'
else
  file_rank  = ""
  file_rank0 = ""
end


path_ps         = pardir + "/" + vname_ps + file_rank  + ".nc"
path_sig_weight = pardir + "/" + vname_ps + file_rank0 + ".nc"

figdir = "figs"


if Dir.exist?(pardir) then
else
  print "Directory, ", pardir, ", does not exist.\n"
  exit
end
if Dir.exist?(figdir) then
else
  print "Directory, ", figdir, ", does not exist.\n"
  exit
end


ENV['SW_LSYSFNT'] = 'true'
ENV['SW_FONTNAME'] = "Helvetica"

iws = ( ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i

# ty (time-lat)
com = "ruby disp_v1_yhflx.rb " + iws.to_s + " " + pardir
print com, "\n"
system( com )
if iws == 2 then
  figfile = "fig_yhflx.pdf"
  com = "mv dcl.pdf" + " " + figdir + "/" + figfile
  print com, "\n"
  system( com )
  #
  com = "convert " +figdir+"/"+figfile + " -rotate 90 \\( +clone -alpha opaque -fill white -colorize 100% \\) +swap -geometry +0+0 -compose Over -composite -alpha off " + figdir+"/"+figfile.sub(/.pdf/, ".png")
  print com, "\n"
  system( com )
end


# ty (time-lat)
vnames = vnames_ty
paths = Array.new(vnames.size)
vnames.each_with_index do |vname, i|
  paths[i] = pardir + "/" + vname + file_rank + ".nc"
end
#
vnames.each_with_index do |vname,i|
  path = paths[i]
  com = "ruby disp_v1_ty.rb " + iws.to_s + " " + path + " " + vname
  print com, "\n"
  system( com )
  if iws == 2 then
    figfile = "fig_ty_" + vname + ".pdf"
    com = "mv dcl.pdf" + " " + figdir + "/" + figfile
    print com, "\n"
    system( com )
    #
    com = "convert " +figdir+"/"+figfile + " -rotate 90 \\( +clone -alpha opaque -fill white -colorize 100% \\) +swap -geometry +0+0 -compose Over -composite -alpha off " + figdir+"/"+figfile.sub(/.pdf/, ".png")
    print com, "\n"
    system( com )
  end
end


# xy (lon-lat)
#
vnames = vnames_xy
paths = Array.new(vnames.size)
vnames.each_with_index do |vname, i|
  paths[i] = pardir + "/" + vname + file_rank + ".nc"
end
#
vnames.each_with_index do |vname,i|
  path = paths[i]

  # xy (lon-lat) annual mean
  com = "ruby disp_v1_xy.rb " + iws.to_s + " " + path + " " + vname
  print com, "\n"
  system( com )
  if iws == 2 then
    figfile = "fig_xy_am_" + vname + ".pdf"
    com = "mv dcl.pdf" + " " + figdir + "/" + figfile
    print com, "\n"
    system( com )
    #
    com = "convert " +figdir+"/"+figfile + " -rotate 90 \\( +clone -alpha opaque -fill white -colorize 100% \\) +swap -geometry +0+0 -compose Over -composite -alpha off " + figdir+"/"+figfile.sub(/.pdf/, ".png")
    print com, "\n"
    system( com )
  end

  # xy (lon-lat) monthly mean
  com = "ruby disp_v1_xy.rb " +
        iws.to_s + " " + path + " " + vname +
        " --meantype month"
  print com, "\n"
  system( com )
  if iws == 2 then
    figfile = "fig_xy_mm_" + vname + ".pdf"
    com = "mv dcl.pdf" + " " + figdir + "/" + figfile
    print com, "\n"
    system( com )
    #
    com = "bash anim-loop_v2.sh " + figdir + "/" + figfile
    print com, "\n"
    system( com )
    #
    com = "rm -f figs-png/*.png figs-pdf/*.pdf"
    print com, "\n"
    system( com )
    #
    figfile = "fig_xy_mm_" + vname + ".mp4"
    com = "mv anim.mp4" + " " + figdir + "/" + figfile
    print com, "\n"
    system( com )
  end
end


# vertical integrated xy (lon-lat)
vnames = vnames_vint_xy
paths = Array.new(vnames.size)
vnames.each_with_index do |vname, i|
  paths[i] = pardir + "/" + vname + file_rank + ".nc"
end
#
vnames.each_with_index do |vname,i|
  path = paths[i]

  # vertical integrated xy (lon-lat) annual mean
  com = "ruby disp_v1_vint_xy.rb " +
        iws.to_s + " " + path + " " + vname +
        " " + path_ps +
        " --path_sig_weight " + path_sig_weight
  print com, "\n"
  system( com )
  if iws == 2 then
    figfile = "fig_xy_am_" + vname + ".pdf"
    com = "mv dcl.pdf" + " " + figdir + "/" + figfile
    print com, "\n"
    system( com )
    #
    com = "convert " +figdir+"/"+figfile + " -rotate 90 \\( +clone -alpha opaque -fill white -colorize 100% \\) +swap -geometry +0+0 -compose Over -composite -alpha off " + figdir+"/"+figfile.sub(/.pdf/, ".png")
    print com, "\n"
    system( com )
  end

  # vertical integrated xy (lon-lat) monthly mean
  com = "ruby disp_v1_vint_xy.rb " +
        iws.to_s + " " + path + " " + vname +
        " " + path_ps +
        " --path_sig_weight " + path_sig_weight + 
        " --meantype month"
  print com, "\n"
  system( com )
  if iws == 2 then
    figfile = "fig_xy_mm_" + vname + ".pdf"
    com = "mv dcl.pdf" + " " + figdir + "/" + figfile
    print com, "\n"
    system( com )
    #
    com = "bash anim-loop_v2.sh " + figdir + "/" + figfile
    print com, "\n"
    system( com )
    #
    com = "rm -f figs-png/*.png figs-pdf/*.pdf"
    print com, "\n"
    system( com )
    #
    figfile = "fig_xy_mm_" + vname + ".mp4"
    com = "mv anim.mp4" + " " + figdir + "/" + figfile
    print com, "\n"
    system( com )
  end
end


# yp (lat-p)
vnames         = vnames_yp
vnames_in_file = Array.new(vnames.size)
vnames.each_with_index do |vname, i|
  case vname
  when "MSF" then
    vname_in_file = "V"
  when "AngMom" then
    vname_in_file = "U"
  when "PotTemp", "StatStab" then
    vname_in_file = "Temp"
  else
    vname_in_file = vname
  end
  paths[i]          = pardir + "/" + vname_in_file + file_rank + ".nc"
  vnames_in_file[i] = vname_in_file
end
#
["lin", "log"].each do |yaxis|
  vnames.each_with_index do |vname,i|
    path          = paths[i]
    vname_in_file = vnames_in_file[i]

    # yp (lat-p) annual mean
    cnttype = "lin"
    if yaxis == "log" then
      if ( vname == "MSF" ) || ( vname == "OMG" ) then
        cnttype = "log"
      end
    end
    com = "ruby disp_v1_yp.rb " +
          iws.to_s + " " + path + " " + vname + " " + path_ps +
          " --yaxis " + yaxis +
          " --cnttype " + cnttype +
          " --vname-in-file " + vname_in_file
    print com, "\n"
    system( com )
    if iws == 2 then
      figfile = "fig_yp" + yaxis + "_am_" + vname + ".pdf"
      com = "mv dcl.pdf" + " " + figdir + "/" + figfile
      print com, "\n"
      system( com )
      #
      com = "convert " +figdir+"/"+figfile + " -rotate 90 \\( +clone -alpha opaque -fill white -colorize 100% \\) +swap -geometry +0+0 -compose Over -composite -alpha off " + figdir+"/"+figfile.sub(/.pdf/, ".png")
      print com, "\n"
      system( com )
    end
  end

  # yp (lat-p) monthly mean
  vnames.each_with_index do |vname,i|
    path          = paths[i]
    vname_in_file = vnames_in_file[i]

    cnttype = "lin"
    if yaxis == "log" then
      if ( vname == "MSF" ) || ( vname == "OMG" ) then
        cnttype = "log"
      end
    end
    com = "ruby disp_v1_yp.rb " + 
          iws.to_s + " " + path + " " + vname + " " + path_ps +
          " --yaxis " + yaxis +
          " --cnttype " + cnttype +
          " --vname-in-file " + vname_in_file + 
          " --meantype month"
    print com, "\n"
    system( com )
    if iws == 2 then
      figfile = "fig_yp" + yaxis + "_mm_" + vname + ".pdf"
      com = "mv dcl.pdf" + " " + figdir + "/" + figfile
      print com, "\n"
      system( com )
      #
      com = "bash anim-loop_v2.sh " + figdir + "/" + figfile
      print com, "\n"
      system( com )
      #
      com = "rm -f figs-png/*.png figs-pdf/*.pdf"
      print com, "\n"
      system( com )
      #
      figfile = "fig_yp" + yaxis + "_mm_" + vname + ".mp4"
      com = "mv anim.mp4" + " " + figdir + "/" + figfile
      print com, "\n"
      system( com )
    end
  end

end
